;------------------------------------------------------------------------------------------------------
;Name		:Definitions
;------------------------------------------------------------------------------------------------------
;------------Define Segments---------------------------------------------------------------------------
equ		SegmentDefinitions			=0x000B
equ		SegmentMainProgram			=0x0014
equ		SegmentProgramVersion		=0x0002
equ		SegmentCPU					=0x0064
equ		SegmentInterrupts			=0x0074
equ		SegmentIOPorts				=0x0094
equ		SegmentEEPROM				=0x00D4
equ		SegmentProgramRoutines		=0x00F4
equ		SegmentLCDRoutines			=0x0224
equ		SegmentDelays				=0x0284
equ		SegmentExternalInterrupt0	=0x02A4
;------------Define Interrupt Vectors------------------------------------------------------------------
equ		_RESET_VECTOR				=0x0000
equ		_EXTERNAL_INTERRUPT0		=0x0001
;------------Define Registers--------------------------------------------------------------------------
def		DelayRegisterA				=r11
def		DelayRegisterC				=r12
def		DisplayCharacterC			=r13
def		DisplayCharacterB			=r14
def		DisplayCharacterA			=r15
def		TempRegister				=r16
def		ProgramFlagRegister			=r17
def		TimeFlagRegister			=r18
def		BaseTimeRegister			=r19
def		SecondRegister				=r20
def		MinuteRegister				=r21
def		HourRegister				=r22
def		TempRegisterB				=r23
def		DelayRegisterB				=r24
def		AccelerationZeroRegisterHigh=r25
def		AccelerationZeroRegisterLow	=r26
def		AccelerationTimeRegisterHigh=r27
def		AccelerationTimeRegisterLow	=r28
def		LastMeasurement				=r29
;------------Define ProgramFlagRegister Bits-----------------------------------------------------------
equ		SetInterruptFlag			=0b00000001
equ		ClrInterruptFlag			=0b11111110
equ		InterruptFlag				=0x00
;------------Define TimeFlagRegister Bits--------------------------------------------------------------
equ		SetSecondFlag				=0b00000001
equ		SetMinuteFlag				=0b00000010
equ		SetHourFlag					=0b00000100
equ		SetDayFlag					=0b00001000
equ		ClrSecondFlag				=0b11111110
equ		ClrMinuteFkag				=0b11111101
equ		ClrHourFlag					=0b11111011
equ		ClrDayFlag					=0b11110111
equ		SecondFlag					=0x00
equ		MinuteFlag					=0x01
equ		HourFlag					=0x02
equ		DayFlag						=0x03
;------------Define Ports and Pins---------------------------------------------------------------------
equ		PortLCDDirection			=DDRB
equ		PortLCD						=PORTB
equ		PortE						=PORTB
equ		PortRS						=PORTB
equ		PortRW						=PORTB
equ		PortData4					=PORTB
equ		PortData5					=PORTB
equ		PortData6					=PORTB
equ		PortData7					=PORTB
equ		PortLCDLed					=PORTB
equ		PinData4					=0x00
equ		PinData5					=0x01
equ		PinData6					=0x02
equ		PinData7					=0x03
equ		PinE						=0x04
equ		PinRW						=0x05
equ		PinRS						=0x06
equ		PinLCDLed					=0x07
equ		PinAccelerometter			=0x05
;------------Define Constants--------------------------------------------------------------------------
equ		_STACK_POINTER_START_ADDRESS=0xDF
equ		_TIMER1_VALUE_HIGH			=0x00
equ		_TIMER1_VALUE_LOW			=0x00
equ		_TIMER0_VALUE				=60
equ		_SEC_IN_1MIN				=60
equ		_MIN_IN_1HOUR				=60
equ		_HOURS_IN_1DAY				=24
equ		_WIRE4_LINES2_FONTS5x7		=0b00100000
equ		_DISPLAYON_CURSOROFF_BLINKOFF=0b00001100
equ		_ADDRESSINCREMENT_SCROLLINGNO=0b00000110
equ		_LINE1						=0b10000000
equ		_LINE2						=0b11000000
equ		_100_USEC					=110
equ		_4_1_MSEC					=41
equ		_15_MSEC					=150
equ		_25_MSEC					=255
equ		_250_MSEC					=10
equ		_500_MSEC					=20
equ		_1_SEC						=40
equ		_CALLIBRATION_TIMES			=16
equ		_NUMBER0					=0x30
equ		_NUMBER1					=0x31
equ		_NUMBER2					=0x32
equ		_NUMBER3					=0x33
equ		_NUMBER4					=0x34
equ		_NUMBER5					=0x35
equ		_NUMBER6					=0x36
equ		_NUMBER7					=0x37
equ		_NUMBER8					=0x38
equ		_NUMBER9					=0x39
equ		_CHAR_UP_DOWN_DOT			=0b00111010
equ		_DIVISOR					=10
equ		_ASCII_0					=0x30




